//Smiley Object, contains eyeballs, hair and mouth
class SteveMonster {
  
  //Properties
  float x,y,size;
  Eyeball leftEye,rightEye;
  
  //Constructor
  SteveMonster(float _x, float _y) {
    size = 100;
    
    x = _x;
    y = _y;
    
    //Setup eyeballs, relative to center of circle
    leftEye  = new Eyeball(-20, -10, 30);
    rightEye = new Eyeball(20,  -10, 30);
  }
  
  //--------------------------------------------------------------------------------------
  //Draw everything inside here
  void draw() {
    
    pushMatrix(); //Begin new matrix, everything will be drawn within this matrix
      //Move to x/y of the smiley
      translate(x,y);
      
      //Draw Background first
      fill(255);
      ellipse(0,0,size,size);
      
      //Draw the hair
      drawHair();
      
      //Draw eyes, with atan2 rotation based on entire face's location
      //So that they are looking at the mouse
      //Use mousePressed boolean to set the scale of the eyes to normal or 150% (1.5)
      float rotation = atan2(mouseY - y, mouseX - x);
      if(mousePressed) {
        leftEye.draw(rotation,1.5);
        rightEye.draw(rotation,1.5);
      } else {
        leftEye.draw(rotation,1.0);
        rightEye.draw(rotation,1.0);
      }
      
      
      //Draw the mouth 
      if(mousePressed) {
        drawOpenMouth();
      } else {
        drawClosedMouth();
      }
      
    popMatrix(); //End Drawing by removing matrix
  }
  
  
  //--------------------------------------------------------------------------------------
  //Draw Hair using rotation
  //We can draw the strand at the top of the head then rotate each one
  //based on i so that we get a full head of hair
  //This is only done once per object so we don't need to make a hair  object,
  //But keeping it as it's own function makes it easier to read
  void drawHair() {
      int nStrands = 50;
      for(int i=0; i<nStrands; i++) {
        
        //Create a new matrix for this strand
        pushMatrix();
          //Find rotation in degrees by mapping i to a number between
          //-75 and 75
          float hairRotation = map(i,0,nStrands-1,-75,75);
          
          //Convert this number to radians
          hairRotation = radians(hairRotation);
          
          //Rotate
          rotate(hairRotation);
          
          //Draw strand
          float strandLength = 25;
          
          if(mousePressed) {
            strandLength = random(10, 50);
          }
          
          line(0,-size/2, 0, -size/2 - strandLength);
        popMatrix();
      }
  }
  
  
  //--------------------------------------------------------------------------------------
  //Mouth Drawing
  void drawOpenMouth() {
    fill(0);
    ellipse(0,size/4,15,15);
  }
  
  
  void drawClosedMouth() {
    fill(0);
    line(-20,size/4,20,size/4);
  }
}
